import { IEffectsAction } from 'redux-effects-promise';
import { IFluxNotificationEntity } from '../definition';
export declare class NotificationActionBuilder {
    /**
     * @stable [13.02.2020]
     * @param {string | IEffectsAction} error
     * @returns {IEffectsAction}
     */
    static buildErrorAction(error: string | IEffectsAction): IEffectsAction;
    /**
     * @stable [13.02.2020]
     * @param {string} info
     * @returns {IEffectsAction}
     */
    static buildInfoAction(info: string): IEffectsAction;
    /**
     * @stable [13.02.2020]
     * @param {string} info
     * @returns {IEffectsAction}
     */
    static buildPlainInfoAction(info: string): IEffectsAction;
    /**
     * @stable [23.01.2021]
     * @param payload
     */
    static buildPlainErrorAction(payload: string | IEffectsAction): IEffectsAction<IFluxNotificationEntity>;
    /**
     * @stable [13.02.2020]
     * @returns {IEffectsAction}
     */
    static buildPlainClearAction(): IEffectsAction;
}
