import { IEntity } from '../../../definitions.interface';
import { IMultiFieldChangesEntity, IMultiFieldPlugin } from './multifield.interface';
import { IMultiItemEntity, IUniversalField, MultiFieldValueT } from '../../../definition';
export declare class MultiFieldPlugin implements IMultiFieldPlugin {
    private readonly field;
    private readonly fieldConverter;
    /**
     * @stable [21.01.2021]
     * @param field
     */
    constructor(field: IUniversalField);
    /**
     * @stable [21.01.2021]
     * @param item
     */
    onAddItem(item: IMultiItemEntity): void;
    /**
     * @stable [21.01.2021]
     * @param item
     */
    onEditItem(item: IMultiItemEntity): void;
    /**
     * @stable [01.06.2018]
     * @param {IMultiItemEntity} item
     */
    onDeleteItem(item: IEntity): void;
    /**
     * @stable [21.01.2021]
     * @param item
     */
    onMergeItem(item: IMultiItemEntity): void;
    onAdd(item: IMultiItemEntity): IMultiFieldChangesEntity;
    /**
     * @stable [11.08.2018]
     * @param {IMultiItemEntity} item
     * @returns {IMultiFieldChangesEntity}
     */
    onEdit(item: IMultiItemEntity): IMultiFieldChangesEntity;
    /**
     * @stable [18.08.2018]
     * @param {IMultiItemEntity} item
     * @returns {IMultiFieldChangesEntity}
     */
    onDelete(item: IEntity): IMultiFieldChangesEntity;
    /**
     * @stable [21.01.2021]
     */
    get originalValue(): IMultiItemEntity[];
    /**
     * @stable [14.10.2020]
     */
    get activeValue(): IEntity[];
    /**
     * @stable [02.06.2018]
     * @param {MultiFieldValueT} value
     * @returns {number}
     */
    getActiveValueLength(value: MultiFieldValueT): number;
    /**
     * @stable [21.01.2021]
     */
    get editValue(): IMultiItemEntity[];
    /**
     * @stable [21.01.2021]
     */
    get addValue(): IEntity[];
    /**
     * @stable [21.01.2021]
     * @param payload
     */
    private onChangeManually;
    /**
     * @stable [29.08.2020]
     * @private
     */
    private get removeValue();
    /**
     * @stable [21.01.2021]
     * @param result
     */
    private asMultiFieldValue;
    /**
     * @stable [21.01.2021]
     */
    private get value();
}
