import { EntityIdT, IEntity, IKeyValue } from '../../../definitions.interface';
import { IMultiFieldChangesEntity } from './multifield.interface';
import { IMultiItemEntity, MultiFieldSingleValueT, MultiFieldValueT } from '../../../definition';
/**
 * @stable [29.07.2019]
 * @param {MultiFieldSingleValueT} multiFieldEntity
 * @returns {EntityIdT}
 */
export declare const toLastAddedMultiItemEntityId: (multiFieldEntity: MultiFieldSingleValueT) => EntityIdT;
/**
 * @stable [18.08.2018]
 * @param {MultiFieldValueT} multiFieldValue
 * @param {(entity: TItem, index: number) => TResult} mapper
 * @returns {TResult[]}
 */
export declare function fromMultiFieldValueToEditedEntities<TItem extends IEntity = IEntity, TResult = IEntity>(multiFieldValue: MultiFieldValueT<TItem>, mapper: (entity: TItem, index: number) => TResult): TResult[];
/**
 * @stable [04.07.2018]
 * @param {IMultiItemEntity[]} multiItemEntities
 * @returns {IKeyValue}
 */
export declare const fromMultiItemEntitiesToFieldsChanges: (multiItemEntities: IMultiItemEntity[]) => IKeyValue;
/**
 * @stable [11.08.2018]
 * @param {IMultiItemEntity} first
 * @param {IMultiItemEntity} second
 * @returns {boolean}
 */
export declare const isSameEntityByIdAndChangedFieldName: (first: IMultiItemEntity, second: IMultiItemEntity) => boolean;
/**
 * @stable [11.08.2018]
 * @param {IMultiItemEntity} item
 * @param {IEntity[]} addValue
 * @param {IMultiItemEntity[]} removeValue
 * @param {IMultiItemEntity[]} editValue
 * @param {IEntity[]} originalValue
 * @returns {IMultiFieldChangesEntity}
 */
export declare const toMultiFieldChangesEntityOnEdit: (item: IMultiItemEntity, addValue: IEntity[], removeValue: IMultiItemEntity[], editValue: IMultiItemEntity[], originalValue: IEntity[]) => IMultiFieldChangesEntity;
/**
 * @stable [18.08.2018]
 * @param {IMultiItemEntity} item
 * @param {IEntity[]} addValue
 * @param {IMultiItemEntity[]} removeValue
 * @param {IMultiItemEntity[]} editValue
 * @param {IEntity[]} originalValue
 * @returns {IMultiFieldChangesEntity}
 */
export declare const toMultiFieldChangesEntityOnDelete: (item: IMultiItemEntity, addValue: IEntity[], removeValue: IMultiItemEntity[], editValue: IMultiItemEntity[], originalValue: IEntity[]) => IMultiFieldChangesEntity;
