/**
 * @stable [16.05.2020]
 */
export declare enum RegexpEnum {
    EMAIL = "^.+@.+$",
    NUMBER = "[-+]?[0-9]*[.,]?[0-9]+",
    POSITIVE_INTEGER = "^\\d+$",
    POSITIVE_NUMBER = "^\\d*\\.?\\d+$",
    POSITIVE_OR_NEGATIVE_INTEGER = "^-?\\d+$",
    POSITIVE_OR_NEGATIVE_NUMBER = "^-?\\d*\\.?\\d+$",
    POSITIVE_OR_NEGATIVE_PRICE = "^[-+]?\\d+(\\.\\d{1,4})?$",
    PRICE = "^\\d+(\\.\\d{1,4})?$",
    SPECIAL_CHARACTER = "[^A-Za-z0-9]"
}
/**
 * @stable [16.05.2020]
 */
export declare class RegexpConstants {
    static readonly EMAIL: RegExp;
    static readonly NUMBER: RegExp;
    static readonly POSITIVE_INTEGER: RegExp;
    static readonly POSITIVE_NEGATIVE_PRICE: RegExp;
    static readonly POSITIVE_NUMBER: RegExp;
    static readonly POSITIVE_OR_NEGATIVE_INTEGER: RegExp;
    static readonly POSITIVE_OR_NEGATIVE_NUMBER: RegExp;
    static readonly PRICE: RegExp;
    static readonly SPECIAL_CHARACTER: RegExp;
}
