import { IDataWrapper, IValidWrapper } from '../definitions.interface';
/**
 * @enum
 * @stable [07.09.2020]
 */
export declare enum ValidationRulesEnum {
    EMAIL = 0,
    EMAIL_OPTIONAL = 1,
    NOT_EMPTY_MULTI_ENTITY = 2,
    NOT_EMPTY_OBJECT = 3,
    NOT_EMPTY_STRING = 4,
    POSITIVE_NUMBER = 5,
    POSITIVE_NUMBER_LIKE = 6,
    POSITIVE_OPTIONAL_NUMBER_LIKE = 7,
    POSITIVE_OR_NEGATIVE_NUMBER = 8,
    POSITIVE_OR_NEGATIVE_NUMBER_LIKE = 9,
    POSITIVE_OR_NEGATIVE_OPTIONAL_NUMBER_LIKE = 10,
    STRING = 11,
    STRONG_OPTIONAL_PASSWORD = 12,
    STRONG_PASSWORD = 13
}
/**
 * @table [22.01.2021]
 */
export declare type ValidationRulesRecordT = Record<ValidationRulesEnum, boolean>;
/**
 * @entity
 * @stable [07.09.2020]
 */
export interface IValidationResultEntity<TEntity = unknown> extends IDataWrapper<Record<keyof TEntity, ValidationRulesRecordT>>, IValidWrapper {
}
