"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChainedMiddlewareFactories = void 0;
var util_1 = require("../../util");
var action_1 = require("../../action");
/**
 * @middleware
 * @stable [20.01.2021]
 *
 * @param cfg
 */
var makeChainedMiddleware = function (cfg) {
    return util_1.Selectors.preventEffectsFromAction(cfg.action)
        ? null
        : [
            action_1.StackActionBuilder.buildLockAction(util_1.CalcUtils.calc(cfg.nextSection, cfg)),
            action_1.RouterActionBuilder.buildNavigateAction(util_1.CalcUtils.calc(cfg.path, cfg))
        ];
};
/**
 * @stable [20.01.2021]
 */
var ChainedMiddlewareFactories = /** @class */ (function () {
    function ChainedMiddlewareFactories() {
    }
    ChainedMiddlewareFactories.chainedMiddleware = makeChainedMiddleware;
    return ChainedMiddlewareFactories;
}());
exports.ChainedMiddlewareFactories = ChainedMiddlewareFactories;
//# sourceMappingURL=chained.middleware.js.map