"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FnUtils = void 0;
var util_1 = require("../util");
/**
 * @stable [18.01.2021]
 * @param sourceFn
 * @param nextFn
 * @param nextFnScope
 */
var sequence = function (sourceFn, nextFn, nextFnScope) {
    return function () {
        if (util_1.TypeUtils.isFn(sourceFn)) {
            sourceFn.apply(this, arguments);
        }
        nextFn.apply(nextFnScope || this, arguments);
    };
};
/**
 * @stable [18.01.2021]
 */
var noop = function () {
    // Do nothing
};
/**
 * @stable [18.01.2021]
 */
var nullNoop = function () { return null; };
/**
 * @stable [18.01.2021]
 */
var FnUtils = /** @class */ (function () {
    function FnUtils() {
    }
    FnUtils.noop = noop;
    FnUtils.nullNoop = nullNoop;
    FnUtils.sequence = sequence;
    return FnUtils;
}());
exports.FnUtils = FnUtils;
//# sourceMappingURL=fn.js.map