/// <reference types="react" />
import { IMultiFieldValueConcatConfigEntity, IMultiFieldValueFilterConfigEntity, IMultiFieldValueMergeConfigEntity, IMultiItemEntity, IReduxMultiEntity, MultiFieldValueOrEntitiesIdsT, MultiFieldValueOrEntityIdT, MultiFieldValueT, NotMultiFieldValueT } from '../definition';
import { IEntity } from '../definitions.interface';
/**
 * @stable [29.08.2020]
 */
export declare class MultiFieldUtils {
    static readonly asMultiItemEditReplacedEntity: <TEntity extends IEntity = IEntity>(name: string, multiFieldValue: MultiFieldValueT<TEntity>, predicate: (itm: IMultiItemEntity) => boolean, factory: (multiItemEntity: IMultiItemEntity, entity: TEntity) => unknown) => IMultiItemEntity;
    static readonly asMultiItemEntity: <TEntity extends IEntity = IEntity>(name: string, value: unknown, rawData: TEntity, newEntity?: boolean) => IMultiItemEntity;
    static readonly buildPhantomEntity: <TEntity extends IEntity = IEntity>(entity: TEntity, multiFieldValue: MultiFieldValueT<TEntity>) => TEntity;
    static readonly concatMultiFieldValue: <TEntity extends IEntity>(cfg: IMultiFieldValueConcatConfigEntity<TEntity>) => IReduxMultiEntity<IEntity>;
    static readonly filterMultiFieldValue: <TEntity extends IEntity>(cfg: IMultiFieldValueFilterConfigEntity<TEntity>) => IReduxMultiEntity<IEntity>;
    static readonly fromMultiEntity: <TEntity extends IEntity = IEntity>(initial: IReduxMultiEntity<TEntity>) => IReduxMultiEntity<TEntity>;
    static readonly isNotMultiEntity: (value: MultiFieldValueOrEntityIdT) => boolean;
    static readonly multiFieldValueAsDefinedEntities: <TEntity extends IEntity = IEntity>(entity: MultiFieldValueT<TEntity>) => TEntity[];
    static readonly multiFieldValueAsEditEntities: <TEntity extends IEntity = IEntity>(entity: MultiFieldValueT<TEntity>, mappedSourcedItems?: Map<import("react").ReactText, TEntity>) => TEntity[];
    static readonly multiFieldValueAsEntities: <TEntity extends IEntity = IEntity>(entity: MultiFieldValueT<TEntity>) => TEntity[];
    static readonly multiFieldValueAsEntitiesIds: <TEntity extends IEntity = IEntity, TResult extends import("react").ReactText = import("react").ReactText>(multiFieldValueOrEntitiesIds: MultiFieldValueOrEntitiesIdsT<TEntity>) => TResult[];
    static readonly multiFieldValueAsMappedEntities: <TEntity = IEntity, TResult = TEntity>(multiFieldValue: MultiFieldValueT<TEntity>, mapper: (entity: TEntity, index?: number) => TResult) => TResult[];
    static readonly multiFieldValueAsMultiItemAddEntities: <TEntity extends IEntity = IEntity>(value: MultiFieldValueT<TEntity>, defaultValue?: TEntity[]) => TEntity[];
    static readonly multiFieldValueAsMultiItemEditEntities: <TEntity extends IEntity = IEntity>(value: MultiFieldValueT<TEntity>, defaultValue?: TEntity[]) => IMultiItemEntity[];
    static readonly multiFieldValueAsMultiItemRemoveEntities: (value: MultiFieldValueT<IEntity>, defaultValue?: IEntity[]) => IEntity[];
    static readonly multiFieldValueAsMultiItemSourceEntities: <TEntity extends IEntity = IEntity>(value: MultiFieldValueT<TEntity>, defaultValue?: TEntity[]) => TEntity[];
    static readonly multiFieldValueAsTrueEntitiesObject: <TEntity extends IEntity = IEntity>(cfg: IMultiFieldValueMergeConfigEntity<TEntity, unknown>) => Record<import("react").ReactText, boolean>;
    static readonly multiFieldValueAsUnknownEntitiesObject: <TEntity extends IEntity, TValue = unknown>(cfg: IMultiFieldValueMergeConfigEntity<TEntity, TValue>) => Record<import("react").ReactText, TValue>;
    static readonly multiItemEntityAsEntity: <TEntity extends IEntity = IEntity>(multiItemEntity: IMultiItemEntity) => TEntity;
    static readonly notMultiFieldValueAsEntities: <TEntity extends IEntity = IEntity>(value: NotMultiFieldValueT<TEntity>) => TEntity[];
}
